/*			Win_LNKS.s V 1.0
		(c) 2003 by Dimitri Junker
			Adenauerallee 30
			52066 Aachen

		Dieses File ist Teil des In2Cat-Projektes und steht unter der
		In2Cat Public License. Dementspechend ist es Freeware und darf
		entsprechend der o.g. Liscense weitergegeben und verndert werden.
		Eine Kopie der In2Cat Public License liegt diesem Paket bei
		Diese Copyright Meldung darf nur vom Copyright Inhaber gendert werden.
		Dieses File entstand auf Basis ses Beispielfiles von ASH.
*/

GLOBL unLnkPath,dll_version,dll_versionAbwC,emuDate,getDrivePath,Trapper
GLOBL pcSymlink,getShortPath,getLongPathMPC,addDIR2List,findDIRbyHdl
GLOBL findDIRbyName,getDIR,delDIR,setDIRHdl,unlnkMPC,setDrivePath
GLOBL logfile,getEnv,cpyWinBlk,replEnv,isOnWinFS,addFSP2List,getFSP
GLOBL winPexec,setScrp,emu_getexepath,newCString,deleteCString,copyCString
GLOBL setAktPathDll,setAktPath
*                                                 FS  15.08.96
*
*   =============================================================
*   Beispiel fr den Aufruf der MPS-Funktionen von Motorola aus
*   =============================================================
*
* Quelle Windows-seitig:
* ----------------------
* mps_base.cpp, mps_demo.cpp
*
mps_code .equ  $4fbf                   * !! NICHT NDERN !!
DLL_ID   .equ  $44594a02               * hier eigene DLL_ID eintragen


* -------------------------------------------------------------------- */
*		Funktionen														*/
* -------------------------------------------------------------------- */
.text

; int dll_version(void);
MODULE dll_version
*     ===========================    * Funktion 10 aufrufen:
	dc.w     mps_code                * = $4fbf 
	dc.l     DLL_ID                  * = eigene DLL_ID
	dc.w     0                       * Funktionsnummer (hier 0)
*     ===========================
	rts
ENDMOD
; int dll_versionAbwC(void);
MODULE dll_versionAbwC
*     ===========================    * Funktion 15 aufrufen:
	dc.w     mps_code                * = $4fbf 
	dc.l     DLL_ID                  * = eigene DLL_ID
	dc.w     1                       * Funktionsnummer (hier 1)
*     ===========================
	rts
ENDMOD
;int unLnkPath(char *mzFile, char* mqFile,BOOL chkFst);
MODULE unLnkPath
*     ===========================      * Funktion 2 aufrufen:
	move.b	1(a1),d1					; DYJ 1.15b
	cmp.b	#$3A,d1						; DYJ 1.15b
	beq		ulp							; DYJ 1.15b
	movem.l D0-D2/A0-A1,-(SP)
	bsr		setAktPath					; DYJ 1.15b
	movem.l (SP)+,D0-D2/A0-A1
ulp:dc.w     mps_code                * = $4fbf 
	dc.l     DLL_ID                  * = eigene DLL_ID
	dc.w     2                       * Funktionsnummer (hier 2)
*     ===========================
	rts
ENDMOD
;BOOL pcSymlink(char *oldname,char *newname);		/*DYJ 0.20b */	
MODULE pcSymlink
*     ===========================      * Funktion 3 aufrufen:
	dc.w     mps_code                * = $4fbf 
	dc.l     DLL_ID                  * = eigene DLL_ID
	dc.w     3                       * Funktionsnummer (hier 3)
*     ===========================
	rts
ENDMOD

;BOOL getShortPath(char *shortName,size_t len, char *longName);
MODULE getShortPath
*     ===========================      * Funktion 4 aufrufen:
	dc.w     mps_code                * = $4fbf 
	dc.l     DLL_ID                  * = eigene DLL_ID
	dc.w     4                       * Funktionsnummer (hier 4)
*     ===========================
	rts
ENDMOD

 
;int getLongPathMPC(char *mzFile, const char* mqFile);
MODULE getLongPathMPC
*     ===========================      * Funktion 5 aufrufen:
	dc.w     mps_code                * = $4fbf 
	dc.l     DLL_ID                  * = eigene DLL_ID
	dc.w     5                       * Funktionsnummer (hier 5)
*     ===========================
	rts
ENDMOD
;void addDIR2List(int flag,char *name)
MODULE addDIR2List
*     ===========================      * Funktion 6 aufrufen:
	dc.w     mps_code                * = $4fbf 
	dc.l     DLL_ID                  * = eigene DLL_ID
	dc.w     6                       * Funktionsnummer (hier 6)
*     ===========================
	rts
ENDMOD
;long findDIRbyHdl(long dirh)
MODULE findDIRbyHdl
*     ===========================      * Funktion 7 aufrufen:
	dc.w     mps_code                * = $4fbf 
	dc.l     DLL_ID                  * = eigene DLL_ID
	dc.w     7                       * Funktionsnummer (hier 7)
*     ===========================
	rts
ENDMOD
;long findDIRbyName(char *name)
MODULE findDIRbyName
*     ===========================      * Funktion 8 aufrufen:
	dc.w     mps_code                * = $4fbf 
	dc.l     DLL_ID                  * = eigene DLL_ID
	dc.w     8                       * Funktionsnummer (hier 8)
*     ===========================
	rts
ENDMOD
;int getDIR(long *hdl,char *name,long pos)
MODULE getDIR
*     ===========================      * Funktion 9 aufrufen:
	dc.w     mps_code                * = $4fbf 
	dc.l     DLL_ID                  * = eigene DLL_ID
	dc.w     9                       * Funktionsnummer (hier 9)
*     ===========================
	rts
ENDMOD
;void delDIR(long pos)
MODULE delDIR
*     ===========================      * Funktion 10 aufrufen:
	dc.w     mps_code                * = $4fbf 
	dc.l     DLL_ID                  * = eigene DLL_ID
	dc.w     10                       * Funktionsnummer (hier 10)
*     ===========================
	rts
ENDMOD
;void setDIRHdl(long pos,long hdl);
MODULE setDIRHdl
*     ===========================      * Funktion 11 aufrufen:
	dc.w     mps_code                * = $4fbf 
	dc.l     DLL_ID                  * = eigene DLL_ID
	dc.w     11                       * Funktionsnummer (hier 11)
*     ===========================
	rts
;unlnkMPC(char *mzFile, const char* mqFile,int mode)
MODULE unlnkMPC
*     ===========================      * Funktion 12 aufrufen:
	move.b	1(a1),d1					; DYJ 1.15b
	cmp.b	#$3A,d1						; DYJ 1.15b
	beq		ulm							; DYJ 1.15b
	movem.l D0-D2/A0-A1,-(SP)
	bsr		setAktPath					; DYJ 1.15b
	movem.l (SP)+,D0-D2/A0-A1
ulm:dc.w     mps_code                * = $4fbf 
	dc.l     DLL_ID                  * = eigene DLL_ID
	dc.w     12                       * Funktionsnummer (hier 12)
*     ===========================
	rts
ENDMOD
;void setDrivePath(int mpcLw,char *winPfad)
MODULE setDrivePath
*     ===========================      * Funktion 13 aufrufen:
	dc.w     mps_code                * = $4fbf 
	dc.l     DLL_ID                  * = eigene DLL_ID
	dc.w     13                       * Funktionsnummer (hier 13)
*     ===========================
	rts
ENDMOD
;BOOL logfile(char* str);
MODULE logfile
*     ===========================      * Funktion 14 aufrufen:
	dc.w     mps_code                * = $4fbf 
	dc.l     DLL_ID                  * = eigene DLL_ID
	dc.w     14                       * Funktionsnummer (hier 14)
*     ===========================
	rts
ENDMOD

;long getEnv(long *ptr,char *name);
MODULE getEnv
*     ===========================      
	dc.w     mps_code      
	dc.l     DLL_ID   
	dc.w     15
*     ===========================
	rts
ENDMOD
;cpyWinBlk(void *ziel,long quell,size_t len,BOOL doFree);
MODULE cpyWinBlk
*     ===========================   
	dc.w     mps_code  
	dc.l     DLL_ID  
	dc.w     16
*     ===========================
	rts
ENDMOD
;long replEnv(long *ptr,char *name);
MODULE replEnv
*     ===========================      
	dc.w     mps_code      
	dc.l     DLL_ID   
	dc.w     17
*     ===========================
	rts
ENDMOD

;BOOL isOnWinFS(char* quell);
MODULE isOnWinFS
*     ===========================      
	dc.w     mps_code      
	dc.l     DLL_ID   
	dc.w     18
*     ===========================
	rts
ENDMOD
;void addFSP2List(DTA *dta,int attr,char *filename)
MODULE addFSP2List
*     ===========================      
	dc.w     mps_code      
	dc.l     DLL_ID   
	dc.w     19
*     ===========================
	rts
ENDMOD
;int getFSP(char *filename,DTA *dta)
MODULE getFSP
*     ===========================      
	dc.w     mps_code      
	dc.l     DLL_ID   
	dc.w     20
*     ===========================
	rts
ENDMOD
;int winPexec(char *fname,char *args,int argvMode,int mode);
MODULE winPexec
*     ===========================      
	dc.w     mps_code      
	dc.l     DLL_ID   
	dc.w     21
*     ===========================
	rts
ENDMOD
;void setScrp(char *file);
MODULE setScrp
*     ===========================      
	dc.w     mps_code      
	dc.l     DLL_ID   
	dc.w     22
*     ===========================
	rts
ENDMOD

; long newCString(void);
MODULE newCString
*     ===========================      
	dc.w     mps_code      
	dc.l     DLL_ID   
	dc.w     23
*     ===========================
	rts
ENDMOD
; void deleteCString(long);
MODULE deleteCString
*     ===========================      
	dc.w     mps_code      
	dc.l     DLL_ID   
	dc.w     24
*     ===========================
	rts
ENDMOD
; void copyCString(char *ziel, long quell);
MODULE copyCString
*     ===========================      
	dc.w     mps_code      
	dc.l     DLL_ID   
	dc.w     25
*     ===========================
	rts
ENDMOD
; void setAktPathDll(char *aktPath);
MODULE setAktPathDll
*     ===========================      
	dc.w     mps_code      
	dc.l     DLL_ID   
	dc.w     26
*     ===========================
	rts
ENDMOD

; long emuDate()
.MODULE emuDate
		moveq		#2,d0
		dc.w		$43bf,$0002
		rts
		
.ENDMOD
; int getDrivePath(int lw,char *buf,long len)
.MODULE getDrivePath
		dc.w		$43bf,$0041
		rts
.ENDMOD
;void emu_getexepath(char *bufadr ,int len);	/*DYJ 1.15a*/
.MODULE emu_getexepath
		dc.w		$43bf,$0003
		rts
.ENDMOD
.MODULE Trapper
	pea (a2)            	* TOS does not save A2 in traps
	move.l	a0,-(sp)		* function
	move.w	d2,-(sp) 		* opcode
	move.w	d1,-(sp) 		* install
	move.w 	d0,-(sp)		* layer
	move.w #555,-(sp)     	* Opcode 555
	trap #14              	* Xbios-Trap
	lea 12(sp),sp         	* correct Stack
	move.l (sp)+,a2       	* restore A2
	rts
.ENDMOD

